Summary: SSL/TLS module for the Apache HTTP server
%ifos Linux
Name: fortitude-mod_nss
%else
Name: fortitude-mod-nss
%endif
Version: 1.0.8
Release: 3%{?dist}
URL: http://directory.fedoraproject.org/wiki/Mod_nss
Group: System Environment/Daemons
Source: %{name}-%{version}.tar.gz
Source1: password.conf
%ifos Solaris
SourcePackage:    RHATfortitude-mod-nss-src
BuildRoot: /var/tmp/%{name}-buildroot
%endif
License: Apache Software License
%ifos Linux
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: make, findutils, perl
BuildRequires: httpd-devel, apr-devel, apr-util-devel
BuildRequires: nspr-devel, nss-devel
Requires: httpd >= 0:2.0.52
Requires: nspr
Requires: nss
%endif
%ifarch sparc
SUNW_Pkg: RHATfortitude-mod-nss
BuildRequires: RHAThttpd-devel, RHATapr-devel, RHATapr-util-devel
BuildRequires: RHATdirsec-nspr-devel >= 4.6.3, RHATdirsec-nss-devel >= 3.11.3
Requires: RHAThttpd >= 0:2.0.52,
Requires: RHATdirsec-nspr >= 4.6.3
Requires: RHATdirsec-nss >= 3.11.3
%endif
%ifarch sparcv9
SUNW_Pkg: RHATfortitude-mod-nssx
BuildRequires: RHAThttpdx-devel, RHATaprx-devel, RHATapr-utilx-devel
BuildRequires: RHATdirsec-nsprx-devel >= 4.6.3, RHATdirsec-nssx-devel >= 3.11.3
Requires: RHAThttpdx >= 0:2.0.52,
Requires: RHATdirsec-nsprx >= 4.6.3
Requires: RHATdirsec-nssx >= 3.11.3
%endif
Patch1: mod_nss-conf.patch
Patch5: mod_nss-cgi.patch

%description
The mod_nss module provides strong cryptography for the Apache Web
server via the Secure Sockets Layer (SSL) and Transport Layer
Security (TLS) protocols using the NSS security library.

%prep
%setup -q
%patch1 -p1 
%patch5 -p1

# Touch expression parser sources to prevent regenerating it
%ifos Linux
touch nss_expr_*.[chyl]
%endif

%ifos Solaris
touch nss_expr_*.[yl]
/usr/bin/sleep 1
touch nss_expr_*.[ch]
%endif

%build

CFLAGS=$RPM_OPT_FLAGS
%ifarch sparcv9
CFLAGS="$CFLAGS -xarch=v9"
%endif
export CFLAGS

%ifos Linux
ARGS="--with-apr-config --enable-ecc"
%else
ARGS="--with-apr-config=/opt/fortitude/bin/apr-config --with-apxs=/opt/fortitude/sbin/apxs"
%endif

%ifarch sparcv9
NSPR_INCLUDE_DIR=`PKG_CONFIG_PATH=/usr/lib/sparcv9/pkgconfig /usr/bin/pkg-config --variable=includedir dirsec-nspr`
NSPR_LIB_DIR=`PKG_CONFIG_PATH=/usr/lib/sparcv9/pkgconfig /usr/bin/pkg-config --variable=libdir dirsec-nspr`

NSS_INCLUDE_DIR=`PKG_CONFIG_PATH=/usr/lib/sparcv9/pkgconfig /usr/bin/pkg-config --variable=includedir dirsec-nss`
NSS_LIB_DIR=`PKG_CONFIG_PATH=/usr/lib/sparcv9/pkgconfig /usr/bin/pkg-config --variable=libdir dirsec-nss`
%else
NSPR_INCLUDE_DIR=`/usr/bin/pkg-config --variable=includedir nspr`
NSPR_LIB_DIR=`/usr/bin/pkg-config --variable=libdir nspr`

NSS_INCLUDE_DIR=`/usr/bin/pkg-config --variable=includedir nss`
NSS_LIB_DIR=`/usr/bin/pkg-config --variable=libdir nss`
%endif

export NSS_INCLUDE_DIR NSS_LIB_DIR
export NSPR_INCLUDE_DIR NSPR_LIB_DIR


./configure --with-nss-lib=$NSS_LIB_DIR --with-nss-inc=$NSS_INCLUDE_DIR --with-nspr-lib=$NSPR_LIB_DIR --with-nspr-inc=$NSPR_INCLUDE_DIR $ARGS

make all

%install
# The install target of the Makefile isn't used because that uses apxs
# which tries to enable the module in the build host httpd instead of in
# the build root.
rm -rf $RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT/opt/fortitude/conf
mkdir -p $RPM_BUILD_ROOT/opt/fortitude/conf.d
mkdir -p $RPM_BUILD_ROOT/opt/fortitude/modules.local
mkdir -p $RPM_BUILD_ROOT/opt/fortitude/bin

%ifos Linux
install -m 644 nss.conf $RPM_BUILD_ROOT/opt/fortitude/conf.d
%else
install -m 644 -c $RPM_BUILD_ROOT/opt/fortitude/conf.d nss.conf
%endif

%ifos Linux
install -m 644 .libs/libmodnss.so $RPM_BUILD_ROOT/opt/fortitude/modules.local
%else
install -m 644 -c $RPM_BUILD_ROOT/opt/fortitude/modules.local .libs/libmodnss.so
%endif

%ifos Linux
install -s -m 755 nss_pcache $RPM_BUILD_ROOT/opt/fortitude/bin
%else
install -s -m 755 -c $RPM_BUILD_ROOT/opt/fortitude/bin nss_pcache
%endiff

%ifos Linux
install -m 755 gencert $RPM_BUILD_ROOT/opt/fortitude/bin
%else
install -m 755 -c $RPM_BUILD_ROOT/opt/fortitude/bin gencert
%endif

%ifos Linux
install -m 644 $RPM_SOURCE_DIR/password.conf $RPM_BUILD_ROOT/opt/fortitude/conf
%else
install -m 644 -c $RPM_BUILD_ROOT/opt/fortitude/conf $RPM_SOURCE_DIR/password.conf
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%files

%ifos Solaris
%attr(00755,root,sys) %dir /opt
%endif
%attr(00755,root,bin) %dir /opt/fortitude
%attr(00755,root,bin) %dir /opt/fortitude/bin
%attr(00755,root,bin) %dir /opt/fortitude/modules.local
%attr(00755,root,bin) %dir /opt/fortitude/conf
%attr(00755,root,bin) %dir /opt/fortitude/conf.d
%attr(00644,root,bin) /opt/fortitude/conf.d/nss.conf
%attr(00644,root,bin) /opt/fortitude/conf/password.conf
%attr(00755,root,bin) /opt/fortitude/modules.local/libmodnss.so
%attr(00755,root,bin) /opt/fortitude/bin/nss_pcache
%attr(00755,root,bin) /opt/fortitude/bin/gencert

%changelog
* Thu Jan 15 2009 Rich Megginson <rmeggins@redhat.com> 1.0.8-3
- retag/release for 2.0 branch

* Thu Jan 15 2009 Rich Megginson <rmeggins@redhat.com> 1.0.8-2
- remove obsolete patches

* Thu Jan 15 2009 Rich Megginson <rmeggins@redhat.com> 1.0.8-1
- updated to version 1.0.8
- updated to use system nspr and nss on RHEL4

* Tue Oct 23 2007 Rob Crittenden <rcritten@redhat.com> 1.0.6-10
- Build on RHEL with --enable-ecc so it is aware of the cipher names
- Update minimum versions of NSS to 3.11.7-3 and NSPR to 4.6.5 on RHEL

* Mon Mar 26 2007 Rob Crittenden <rcritten@redhat.com> 1.0.6-9
- Remove all references to ECC from nss.conf
- Remove --enable-ecc from the configure line

* Thu Feb 22 2007 Rob Crittenden <rcritten@redhat.com> 1.0.6-8
- Add ability to log the cipher without the performance impact of
  exporting all SSL variables. This should help aid in determining
  how many RSA and ECC users there are.
- Cleanup some spec file warnings from rpmlint

* Thu Feb 22 2007 Rob Crittenden <rcritten@redhat.com> 1.0.6-7
- Include password file formatting patch

* Mon Feb 19 2007 Rob Crittenden <rcritten@redhat.com> 1.0.6-6
- Changes to build on Solaris from the Linux SRPM

* Tue Feb 13 2007 Rob Crittenden <rcritten@redhat.com> 1.0.6-5
- Rename package from mod_nss to fortitude-mod_nss

* Tue Feb 13 2007 Rob Crittenden <rcritten@redhat.com> 1.0.6-4
- Remove arch-specific install on Solaris
- Some changes in preparation for building in brew

* Thu Feb  1 2007 Rob Crittenden <rcritten@redhat.com> 1.0.6-3
- Fix typo in the cipher echde_rsa_null

* Wed Jan 10 2007 Rob Crittenden <rcritten@redhat.com> 1.0.6-2
- Log a useful error message then the wrong password is provided.

* Tue Oct 31 2006 Rob Crittenden <rcritten@redhat.com> 1.0.6-1
- Update to 1.0.6

* Tue Oct 10 2006 Matthew Harmsen <mharmsen@redhat.com> 1.0.2-12
- Bumped Release number to 12
- Updated the RPM Requires and BuildRequires to NSS 3.11.3
- Updated the RPM Requires and BuildRequires to NSPR 4.6.3

* Mon Oct  1 2006 Rob Crittenden <rcritten@redhat.com> 1.0.2-11
- Don't drop core if a token password in a file pointed to by
  NSSPassPhraseDialog is incorrect.

* Fri Aug 25 2006 Rob Crittenden <rcritten@redhat.com> 1.0.2-10
- Add new NSSPassPhraseDialog directive, defer. This is similar to the file:
  directive but it only tries to authenticate any tokens listed in the file.

* Tue Aug 22 2006 Rob Crittenden <rcritten@redhat.com> 1.0.2-9
- Use the /usr/bin/certutil wrapper on Solaris 64-bit as well.

* Mon Aug 21 2006 Rob Crittenden <rcritten@redhat.com> 1.0.2-8
- Add patch to move where the SSL session cache is initialized to happen
  before NSS_Init(). A race condition was happening where during the
  first NSS_Shutdown() the cache init wasn't completed and httpd crashed.
- Remove AutoReq
- Remove autoconf
- Remove -s from nss_pcache install so we get debuginfo

* Thu Aug  3 2006 Matthew Harmsen <mharmsen@redhat.com> 1.0.2-7
- Added the Solaris-specific keyword "SourcePackage" with the desired value
  to this specfile; did NOT increment "Release" value for this change.

* Wed Aug  2 2006 Rob Crittenden <rcritten@redhat.com> 1.0.2-7
- Add default LogLevel to nss.conf
- Move some INFO messages to ERR.

* Wed Jul  5 2006 Rob Crittenden <rcritten@redhat.com> 1.0.2-6
- Require >= dirsec-nss-3.11.2 which provides ECC
- Enable ECC support
- Add patch to initialize ECC certificate and key pointers

* Mon May  1 2006 Rob Crittenden <rcritten@redhat.com> 1.0.2-5
- Correct location of NSS on sparcv9

* Fri Apr 28 2006 Rob Crittenden <rcritten@redhat.com> 1.0.2-4
- Solaris 32/64-bit generic binary installation

* Tue Apr 25 2006 Rob Crittenden <rcritten@redhat.com> 1.0.2-3
- Add Solaris-specific %%files entries
- Solaris will listen on 0.0.0.0 by default.

* Thu Apr  6 2006 Rob Crittenden <rcritten@redhat.com> 1.0.2-2
- Pulling tag mod_nss102
- No longer dependant upon fortitude

* Thu Feb 23 2006 Rob Crittenden <rcritten@redhat.com> 1.0-1
- Move the gencert step to the fortitude RPM.

* Tue Aug  9 2005 Rob Crittenden <rcritten@redhat.com> 1.0-0
- Initial build
